C+    prepare_ptw_input.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE FILES ptw.input.1 AND ptw.input.2;
C+    ONE OR BOTH OF THESE IS COPIED TO ptw.input, WHICH IS AN INPUT
C+    FILE REQUIRED FOR CALCULATION OF PERIODIC TRAVELLING WAVE 
C+    SOLUTIONS.
C++   
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO)
      OPEN(12,FILE='../temp_files/control_parameters.data'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)PP
      READ(12,*)C
      CLOSE(12)
      OPEN(13,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)
      READ(13,*)
      READ(13,*)NTST1
      READ(13,*)NTST2
      READ(13,*)NTST3
      CLOSE(13)
      IF (NTST1.LT.NTST2) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: ntst1<ntst2'')')
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
      OPEN(14,FILE='../temp_files/ptw.input.1'
     &,STATUS='NEW')
      WRITE(14,9000)PP,C,NTST1
      CLOSE(14)
      IF (NTST1.GT.NTST2) THEN
         OPEN(15,FILE='../temp_files/ptw.input.2'
     &,STATUS='NEW')
         WRITE(15,9000)PP,C,NTST2
         CLOSE(15)
      ENDIF
      CALL ISTOP(INFO)
 9000 FORMAT(E16.8E2,' PP',/,E16.8E2,' C',/,8X,I8,' ntst')
      END
