C+    extractcontour.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE AUTO OUTPUT FILES FROM A RUN
C+    CALCULATING A LOCUS OF CONSTANT WAVE PERIOD, AND REWRITES 
C+    IT IN A MORE USER-FRIENDLY FORM.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER (MAXLBL=100)
      LOGICAL NFIRST,REPEAT
      DIMENSION DARRAY(6)
      DIMENSION PPLBL(MAXLBL),CLABEL(MAXLBL),
     &     IOLBL(MAXLBL)
      CALL GINFO(INFO)
      ZERO=0.0D0
      IZERO=0
      IONE=1
      OPEN(16,FILE='../temp_files/valueofperiod.data'
     &,STATUS='OLD')
      REWIND(16)
      READ(16,*)PERIOD
      CLOSE(16)
      OPEN(15,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)PPMIN,PPMAX
      READ(15,*)CMIN,CMAX
      CLOSE(15)
      OPEN(12,FILE='p.contourdata'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='../temp_files/contour.contourdata'
     &,STATUS='NEW')
      WRITE(13,9000)ZERO,ZERO,IZERO,ZERO
C-----
      OPEN(18,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(18)
      READ(18,*)NPDE
      READ(18,*)NPTW
      CLOSE(18) 
      IARRAY=MIN(6,NPTW+1) 
C     The significance of iarray is that in the "p." output file, 
C       auto prints the norm and up to 5 variable values between the
C       two continuation parameters.
      DO 200 J=1,12
         READ(12,*)IDUMMY
 200  CONTINUE
      DO 210 J=1,10000
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,
     &        PP,(DARRAY(I),I=1,IARRAY),C
         WRITE(13,9000)PP,C,IONE,PERIOD
 210  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 210 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      CLOSE(12)
      CLOSE(13)
C-----
C     Now read in existing labels (if any)
      OPEN(14,FILE='data_files/contour.labels'
     &,STATUS='OLD')
      REWIND(14)
C     INPUT FILE
      NLABEL=0
      DO 250 I=1,MAXLBL
         READ(14,*,END=251)PPLBL(I),CLABEL(I),IOLBL(I),PRDIN
         NLABEL=I
         IF (PRDIN.NE.PERIOD) THEN
            OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
            WRITE(66,'(''ERROR: DISCREPANCY IN PERIODS'',
     &           '' in extractcontour.f'')')
            CLOSE(66)
            CALL IOUT(INFO,'error')
            CALL ISTOP(INFO)
         ENDIF
 250  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 250 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 251  CLOSE(14)
C     Now check where contour crosses max/min values of pp and c
      ITOP=8
      IBOTTM=2
      ILEFT=4
      IRIGHT=6
      OPEN(13,FILE='../temp_files/contour.contourdata'
     &,STATUS='OLD')
      REWIND(13)
C     NOW AN INPUT FILE
      OPEN(19,FILE='data_files/contour.contourdata'
     &,STATUS='NEW')
      NFIRST=.FALSE.
      DO 300 I=1,10000
         READ(13,*,END=301)PP,C,I01
C         IF ((I01.EQ.0).OR.
C     &        ((PP.GE.PPMIN).AND.(PP.LE.PPMAX).AND.
C     &        (C.GE.CMIN).AND.(C.LE.CMAX))) THEN
            WRITE(19,9000)PP,C,I01,PERIOD
C         ENDIF
C         Note: the IF/ENDIF above was commented out when
C               I added the box around period contour labels.
C               As a result files 13 and 19 are always the 
C               same but I decided to leave the structure
C               with both files in case I decided to revert
C               to the previous approach for contour labelling.
         IF (NFIRST.AND.(I01.NE.0).AND.(I01OLD.NE.0)) THEN
            IF (((PP-PPMAX)*(PPOLD-PPMAX)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=PPMAX
               CLABEL(NLABEL)=(C+COLD)/2.0D0
               IOLBL(NLABEL)=IRIGHT
            ENDIF
            IF (((PP-PPMIN)*(PPOLD-PPMIN)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=PPMIN
               CLABEL(NLABEL)=(C+COLD)/2.0D0
               IOLBL(NLABEL)=ILEFT
            ENDIF
            IF (((C-CMAX)*(COLD-CMAX)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=(PP+PPOLD)/2.0D0
               CLABEL(NLABEL)=CMAX
               IOLBL(NLABEL)=ITOP
            ENDIF
            IF (((C-CMIN)*(COLD-CMIN)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=(PP+PPOLD)/2.0D0
               CLABEL(NLABEL)=CMIN
               IOLBL(NLABEL)=IBOTTM
            ENDIF
         ENDIF
         PPOLD=PP
         COLD=C
         I01OLD=I01
         NFIRST=.TRUE.
 300  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 300 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 301  CLOSE(13)
      CLOSE(19)
C     Now eliminate any label points that are (almost) duplicates or 
C       that are out of range. Use a tolerance of 1% (arbitrary) of 
C       the overall range on each axis (pp and c) to define labels 
C       as being duplicates, or being far enough outside the 
C       plotting region to be designated as out of range.
      PPTOL=(PPMAX-PPMIN)*0.01D0 
      CTOL=(CMAX-CMIN)*0.01D0
      OPEN(14,FILE='data_files/contour.labels'
     &,STATUS='OLD')
      REWIND(14)
C     NOW AN OUTPUT FILE
      DO 400 I=1,NLABEL
         REPEAT=.FALSE.
         DO 401 J=1,I-1
            IF ((ABS(PPLBL(I)-PPLBL(J)).LT.PPTOL).AND.
     &           (ABS(CLABEL(I)-CLABEL(J)).LT.CTOL).AND.
     &           (IOLBL(I).EQ.IOLBL(J))) THEN
               REPEAT=.TRUE.
            ENDIF
 401     CONTINUE
         IF ((.NOT.REPEAT).AND.
     &        (PPLBL(I).GT.(PPMIN-PPTOL)).AND.
     &        (PPLBL(I).LT.(PPMAX+PPTOL)).AND.
     &        (CLABEL(I).GT.(CMIN-CTOL)).AND.
     &        (CLABEL(I).LT.(CMAX+CTOL))) THEN
            WRITE(14,9100)PPLBL(I),CLABEL(I),IOLBL(I),PERIOD
         ENDIF
 400  CONTINUE
      CLOSE(14)
      CALL ISTOP(INFO)
 9000 FORMAT(2E18.10E2,I2,'  hc 0',E18.10E2)
 9100 FORMAT(2E18.10E2,I2,E18.10E2,'  hc 0')
      END
