C+    redo_contourdata_pc_2.f   
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    IF LABELLING (WITH THE PERIOD) IS SELECTED WHEN PLOTTING
C+    PERIOD CONTOURS, THEN THIS PROGRAM IS RUN BEFORE THE PLOTTING
C+    IS DONE. IT REMOVES DATA POINTS THAT LIE INSIDE RECTANGULAR
C+    REGIONS CENTRED ON THE LABEL LOCATIONS, AND ADDS ADDITIONAL 
C+    POINTS AT THE EDGE OF THESE REGIONS (VIA LINEAR INTERPOLATION)
C+    IN ORDER TO AVOID GAPS IN THE CONTOURS BEING BIGGER THAN 
C+    DESIRED. THE SIZE OF THE RECTANGULAR REGIONS IS DETERMINED BY
C+    THE INPUT CONSTANTS xperiodcontourlabelbox AND 
C+    yperiodcontourlabelbox, WHICH ARE SET IN plot_defaults.input.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER (MAXLBL=1000)
      DIMENSION PPLBL(MAXLBL),CLBL(MAXLBL)
      LOGICAL PLTOLD,PLTNEW,TESTOK
      IZERO=0.0D0
      IONE=1.0D0
      OPEN(15,FILE='../temp_files/periodlabelbox.data'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)XPLBOX,YPLBOX
      CLOSE(15)
      OPEN(11,FILE='data_files/periodcontour.contourdata'
     &,STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/periodcontour.contourdata1'
     &,STATUS='NEW')
      OPEN(13,FILE='data_files/periodcontour.newlabels'
     &,STATUS='OLD')
      REWIND(13)
C     Note: the data_files directory referred to here
C           is a subsubdirectory of plotting
      DO 100 I=1,1000
         READ(13,*,END=101)PPLBL(I),CLBL(I)
         NLBL=I
 100  CONTINUE
      WRITE(6,'(''ERROR:'',
     &'' LOOP 100 FINISHED in redo_contourdata_pc_2.f'')')
 101  CLOSE(13)
      OPEN(14,FILE='../temp_files/xyrange.data'
     &,STATUS='OLD')
C     Note: the temp_files directory referred to here
C           is a subdirectory of plotting
      READ(14,*)PPMIN,PPMAX,CMIN,CMAX
      CLOSE(14)
      PPGAP=XPLBOX*(PPMAX-PPMIN)
      CGAP=YPLBOX*(CMAX-CMIN)
      NSTEP=100
      DO 200 I=1,10000
         READ(11,*,END=201)PPNEW,CNEW,I01NEW,IHCNEW
         PLTNEW=.TRUE.
         IF ((I01NEW.NE.0).AND.(IHCNEW.NE.1)
     &        .AND.(I.GT.1)) THEN
            DO 300 J=1,NLBL
               IF ((ABS(PPNEW-PPLBL(J)).LE.PPGAP).AND.
     &              (ABS(CNEW-CLBL(J)).LE.CGAP)) THEN
                  PLTNEW=.FALSE.
               ENDIF
 300        CONTINUE
C     Now generate an extra data point where the contour
C     intersects the box around the label, if appropriate
            IF (((PLTNEW).AND.(.NOT.PLTOLD)).OR.
     &           ((PLTOLD).AND.(.NOT.PLTNEW))) THEN
               DO 400 ISTEP=1,(NSTEP-1)
                  QQQTOP=ISTEP
                  QQQBOT=NSTEP
                  QQQ=QQQTOP/QQQBOT
                  IF (PLTOLD) THEN
                     PPTEST=PPNEW*(1.0D0-QQQ)+PPOLD*QQQ
                     CTEST=CNEW*(1.0D0-QQQ)+COLD*QQQ
                  ELSE
                     PPTEST=PPOLD*(1.0D0-QQQ)+PPNEW*QQQ
                     CTEST=COLD*(1.0D0-QQQ)+CNEW*QQQ
                  ENDIF
                  TESTOK=.TRUE.
                  DO 500 J=1,NLBL
                     IF ((ABS(PPTEST-PPLBL(J)).LE.PPGAP).AND.
     &                    (ABS(CTEST-CLBL(J)).LE.CGAP)) THEN
                        TESTOK=.FALSE.
                     ENDIF
 500              CONTINUE
                  IF (TESTOK) THEN
                     WRITE(12,9000)PPTEST,CTEST,IONE,IZERO
                     GOTO 401
                  ENDIF
 400           CONTINUE
C              Note that if loop 400 finishes then the point that is
C              already being plotted must be only just outside the
C              label box, so no need for an extra point.
 401           CONTINUE
            ENDIF
         ENDIF
C     Now write the data point if appropriate
         IF (PLTNEW) THEN
            WRITE(12,9000)PPNEW,CNEW,I01NEW,IHCNEW
         ELSE
            WRITE(12,9000)PPNEW,CNEW,IZERO,IHCNEW
C           Note that the third entry being zero indicates that the
C           point is not to be plotted. This line is output to create
C           a break in the plotting and thus give a gap in the contour.
         ENDIF
C     Now reset "old" values
         PLTOLD=PLTNEW
         PPOLD=PPNEW
         COLD=CNEW
         I01OLD=I01NEW
         IHCOLD=IHCNEW
 200  CONTINUE
      WRITE(6,'(''ERROR:'',
     &'' LOOP 200 FINISHED in redo_contourdata_pc_2.f'')')
 201  CLOSE(11)
      CLOSE(12)
      STOP
 9000 FORMAT(2E18.10E2,2I2)
      END
