C+    redo_labels_pc.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    IF THE USER OPTS TO USE NON-DEFAULT LOCATIONS FOR
C+    PERIOD CONTOUR LABELS, THEN THIS PROGRAM IS RUN TO
C+    CREATE THE NEW LABELS FILE.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER(MAXLBL=1000)
      LOGICAL LBLOK(MAXLBL)
      DIMENSION PPCNEW(2),PPCOLD(2)
      DIMENSION PPLBL(MAXLBL),CLBL(MAXLBL),PERLBL(MAXLBL)
      ZERO=0.0D0
      OPEN(13,FILE='../temp_files/redo_labels_pc.input'
     &,STATUS='OLD')
      REWIND(13)
C     Note: the data_files directory referred to here
C           is a subsubdirectory of plotting and the
C           temp_files directory is a subdirectory of 
C           plotting
      NLBL=0
      DO 100 ILABEL=1,10000
         READ(13,*,END=101)IPPORC,PPORC
         I01OOD=0
C        I01OOD is the "old" version of I01OLD
         OPEN(11,FILE='data_files/periodcontour.contourdata'
     &        ,STATUS='OLD')
         REWIND(11)
         OPEN(21,FILE='data_files/periodcontour.contourdata1'
     &        ,STATUS='OLD')
         REWIND(21)
         READ(11,*,END=201)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
         WRITE(21,9300)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
         DO 200 IDATA=1,100000
            PPCOLD(1)=PPCNEW(1)
            PPCOLD(2)=PPCNEW(2)
            I01OOD=I01OLD
            I01OLD=I01NEW
            IHCOLD=IHCNEW
            PEROLD=PERNEW
            READ(11,*,END=201)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
            IF ((I01OLD.NE.0).AND.(IHCOLD.EQ.0).AND.
     &           (I01NEW.NE.0).AND.(IHCNEW.EQ.0)) THEN
               IF ((((PPCNEW(IPPORC)-PPORC)*(PPCOLD(IPPORC)-PPORC))
     &              .LT.0).OR.(PPCNEW(IPPORC).EQ.PPORC).OR.
     &               ((I01OOD.EQ.0).AND.(PPCOLD(IPPORC).EQ.PPORC))) 
     &              THEN
                  QQQ=(PPCNEW(IPPORC)-PPORC)/
     &                 (PPCNEW(IPPORC)-PPCOLD(IPPORC))
                  IF (NLBL.EQ.MAXLBL) THEN
                     WRITE(6,'(''ERROR:'',
     &'' NLBL exceeds MAXLBL in redo_labels_pc.f'')')
                     GOTO 101
                  ENDIF
                  NLBL=NLBL+1
                  IF (IPPORC.EQ.1) THEN
                     PPLBL(NLBL)=PPORC
                     CLBL(NLBL)=PPCNEW(2)*(1.0D0-QQQ)+PPCOLD(2)*QQQ
                  ELSE
                     PPLBL(NLBL)=PPCNEW(1)*(1.0D0-QQQ)+PPCOLD(1)*QQQ
                     CLBL(NLBL)=PPORC
                  ENDIF
                  IF (PERNEW.NE.PEROLD) THEN
                     WRITE(6,'(''ERROR:'',
     &'' PERNEW different from PEROLD in redo_labels_pc.f'',/,
     &''        Program will continue using PERNEW'')')
                  ENDIF
                  PERLBL(NLBL)=PERNEW
                  WRITE(21,9300)
     &PPLBL(NLBL),CLBL(NLBL),I01NEW,IHCNEW,PERLBL(NLBL)
               ENDIF
            ENDIF
            WRITE(21,9300)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
 200     CONTINUE
         WRITE(6,'(''ERROR:'',
     &        '' LOOP 200 FINISHED in redo_labels_pc.f'')')
 201     REWIND(11)
         REWIND(21)
C     Now "copy" file 21 into file 11
         DO 300 I300=1,100000
            READ(21,*,END=301)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
            WRITE(11,9300)
     &PPCNEW(1),PPCNEW(2),I01NEW,IHCNEW,PERNEW
 300     CONTINUE
         WRITE(6,'(''ERROR:'',
     &        '' LOOP 300 FINISHED in redo_labels_pc.f'')')
 301     CLOSE(11)
         CLOSE(21)
 100  CONTINUE
      WRITE(6,'(''ERROR:'',
     &'' LOOP 100 FINISHED in redo_labels_pc.f'')')
 101  CLOSE(13)
C     Sometimes continuation via auto will turn around at the
C     end of a period contour, and as a result, label locations will
C     appear more than once in the list (with small differences). Now
C     get rid of this multiplicity, before writing output file.
      OPEN(14,FILE='../temp_files/xyrange.data'
     &,STATUS='OLD')
      READ(14,*)PPMIN,PPMAX,CMIN,CMAX
      CLOSE(14)
      OPEN(15,FILE='../temp_files/periodlabelbox.data'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)XPLBOX,YPLBOX
      CLOSE(15)
      PPGAP=XPLBOX*(PPMAX-PPMIN)
      CGAP=YPLBOX*(CMAX-CMIN)
      DO 400 I=1,NLBL
         LBLOK(I)=.TRUE.
 400  CONTINUE
      DO 401 I=1,NLBL
         DO 402 J=1,(I-1)
            IF ((LBLOK(J)).AND.
     &           (ABS(PPLBL(I)-PPLBL(J)).LE.PPGAP).AND.
     &           (ABS(CLBL(I)-CLBL(J)).LE.CGAP)) THEN
               LBLOK(I)=.FALSE.
            ENDIF
 402     CONTINUE
 401  CONTINUE
      OPEN(12,FILE='data_files/pclabelstouse.labels'
     &,STATUS='NEW')
      WRITE(12,9001)ZERO,ZERO,ZERO
C     This is a dummy line (will not be plotted) to
C     ensure that the file has at least one line.
      DO 403 I=1,NLBL
         IF (LBLOK(I)) THEN
            WRITE(12,9000)PPLBL(I),CLBL(I),PERLBL(I)
         ENDIF
 403  CONTINUE
      CLOSE(12)
      STOP
 9000 FORMAT(2E18.10E2,'  5 ',E18.10E2,' hc 0')
 9001 FORMAT(2E18.10E2,' -1 ',E18.10E2,' hc 0')
 9300 FORMAT(2E18.10E2,2I3,E18.10E2)
      END
