C+    reformat_labels_pc.f   
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    IF LABELLING (WITH THE PERIOD) IS SELECTED WHEN PLOTTING
C+    PERIOD CONTOURS, THEN THIS ROUTINE IS RUN BEFORE THE LABELLING
C+    IS DONE, IN ORDER TO REFORMAT THE PERIOD ACCORDING TO THE 
C+    OPTIONS SET IN THE PLOTTING DEFAULTS FILE. NOTE THAT THIS
C+    PROGRAM IS RUN FROM WITHIN THE PLOTTING ROUTINES NOT THE RUN
C+    ROUTINES. NOTE ALSO THAT THE PROGRAM MUST BE AUGMENTED BY A 
C+    SUBROUTINE (REWRTE) THAT IS WRITTEN BY plotprepare_pc.script
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL INRNGE
      CHARACTER*4 AHC
      CHARACTER*70 ALINE
      OPEN(11,FILE='data_files/pclabelstouse.labelscopy'
     &,STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/pclabelstouse.labels'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='data_files/periodcontour.newlabels'
     &,STATUS='NEW')
C     Note: the data_files directory referred to here
C           is a subsubdirectory of plotting
      OPEN(14,FILE='../temp_files/xyrange.data'
     &,STATUS='OLD')
C     Note: the temp_files directory referred to here
C           is a subdirectory of plotting
      READ(14,*)XMIN,XMAX,YMIN,YMAX
      XRANGE=XMAX-XMIN
      YRANGE=YMAX-YMIN
      CLOSE(14)
      OPEN(15,FILE='../temp_files/periodlabelbox.data'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)XPLBOX,YPLBOX
      CLOSE(15)
      DO 100 I=1,10000
         READ(11,9500,END=101)ALINE
         READ(12,*,END=101)PP,C,IOIENT,PERIOD
C        Shift label locations a bit according to IOIENT.
C        Note that there is no shift if IOIENT=5, which corresponds
C        to the label being centred on the specified point.
         XSHIFT=0.5D0*XPLBOX*XRANGE
         YSHIFT=0.5D0*YPLBOX*YRANGE
         IF (IOIENT.EQ.6) THEN
            PP=PP-XSHIFT
         ENDIF
         IF (IOIENT.EQ.4) THEN
            PP=PP+XSHIFT
         ENDIF
         IF (IOIENT.EQ.8) THEN
            C=C+YSHIFT
         ENDIF
         IF (IOIENT.EQ.2) THEN
            C=C-YSHIFT
         ENDIF
C        Now sort out the formatting of the period
         DO 200 ICHAR=1,67
            AHC=ALINE(ICHAR:ICHAR+3)
            IF (AHC(1:2).EQ.'hc') THEN
               GOTO 201
            ENDIF
 200     CONTINUE
         WRITE(6,'(''ERROR:'',
     &   '' LOOP 200 FINISHED in reformat_labels_pc.f'')')
 201     CONTINUE
         INRNGE=.TRUE.
         IF (PERIOD.GT.(8.9999D9)) THEN
            WRITE(13,9001)PP,C,IOIENT,AHC
            INRNGE=.FALSE.
         ENDIF
         IF (PERIOD.LT.(1.0001D-9)) THEN
            WRITE(13,9002)PP,C,IOIENT,AHC
            INRNGE=.FALSE.
         ENDIF
         IF (INRNGE) THEN
            CALL REWRTE(PP,C,IOIENT,PERIOD,AHC)
         ENDIF
 100  CONTINUE
      WRITE(6,'(''ERROR:'',
     &'' LOOP 100 FINISHED in reformat_labels_pc.f'')')
 101  CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      STOP
 9001 FORMAT(2E18.10E2,I3,' Inf',X,A4)
 9002 FORMAT(2E18.10E2,I3,' 0',X,A4)
 9500 FORMAT(A70)
      END
