C+    extractbd.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE AUTO OUTPUT FILES FROM A RUN CALCULATING
C+    A BIFURCATION DIAGRAM, AND WRITES MORE USER-FRIENDLY DATA FILES.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO)
      ZERO=0.0D0
      IZERO=0
      IONE=1
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='data_files/bd.newdata'
     &,STATUS='NEW')
      WRITE(13,9000)ZERO,ZERO,ZERO,ZERO,ZERO,ZERO,ZERO,IZERO
      OPEN(15,FILE='data_files/hb_and_folds.newdata'
     &,STATUS='NEW')
      DO 100 I=1,12
         READ(12,*)IDUMMY
 100  CONTINUE
      DO 200 I=1,100000
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,PP,RNORM,
     &        RMAXU,PERIOD,UMAX,UMEAN,UMIN,UNORM
         WRITE(13,9000)PP,RNORM,PERIOD,UMAX,UMEAN,UMIN,UNORM,IONE
         IF (I.EQ.1) THEN
C     THE HOPF BIFN POINT
            WRITE(15,9001)PP,RNORM,PERIOD,UMAX,UMEAN,UMIN,UNORM
         ENDIF
         IF (ITY.EQ.5) THEN
C     THE POINT IS A FOLD
            WRITE(15,9002)PP,RNORM,PERIOD,UMAX,UMEAN,UMIN,UNORM
         ENDIF
 200  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 200 FINISHED in extractbd.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      IF (ITY.EQ.(-9)) THEN
         WRITE(15,9003)PP,RNORM,PERIOD,UMAX,UMEAN,UMIN,UNORM
C        This means that the branch ended with a convergence error, which
C        is typically due to a homoclinic solution being approached. The
C        end point is not flagged otherwise, since this will (almost 
C        certainly) be due to the end point of the parameter range being
C        reached.
      ENDIF
      CLOSE(12)
      CLOSE(13)
      CLOSE(15)
      CALL ISTOP(INFO)
 9000 FORMAT(7E18.10E2,I2)
 9001 FORMAT(7E18.10E2,2X,
     &     '1 HOPF BIFN POINT')
 9002 FORMAT(7E18.10E2,2X,
     &     '2 FOLD')
 9003 FORMAT(7E18.10E2,2X,
     &     '3 END OF SOLN BRANCH')
      END
