C+    extracthopf.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THE FIRST PART OF THE CALCULATION OF STABILITY BOUNDARIES OF 
C+    HOPF TYPE IS THE IDENTIFICATION OF A SMALL REGION OF THE SPECTRUM
C+    CONTAINING THE FOLD WITH THE LARGEST REAL PART (EXCLUDING THE 
C+    ORIGIN). THAT IS DONE BY NUMERICAL CONTINUATION OF THE PERIODIC
C+    TRAVELLING WAVE AND EIGENFUNCTION EQUATIONS, THE END POINT OF 
C+    WHICH IS THE SOLUTIONS AT ONE END OF THE SMALL REGION. THIS 
C+    PROGRAM READS IN THE AUTO FILES CONTAINING THIS SOLUTION, AND 
C+    WRITES A DATA FILE THAT CAN BE USED AS A STARTING POINT FOR 
C+    CONTINUATION OF THE HOPF EQUATIONS, IN WHICH THE PERIODIC 
C+    TRAVELLING WAVE AND EIGENFUNCTION EQUATIONS ARE AUGMENTED BY
C+    EQUATIONS FOR THE REAL AND IMAGINARY PARTS OF THE FIRST 
C+    DERIVATIVE OF THE EIGENFUNCTION WITH RESPECT TO I*GAMMA.
C+    THE SOLUTION IN THIS DATA FILE WILL BE REFINED BY DOING 
C+    CONTINUATION WITH AUTO IN A DUMMY PARAMETER, PRIOR TO REAL 
C+    CONTINUATION. THIS PROGRAM ALSO WRITES A SECOND FILE THAT 
C+    CONTAINS THE STARTING VALUES OF THE REAL AND IMAGINARY PARTS
C+    OF THE EIGENVALUE, AND ESTIMATES OF THE REAL AND IMAGINARY 
C+    PARTS OF THE DERIVATIVE OF THE EIGENVALUE AND EIGENFUNCTION 
C+    WITH RESPECT TO I*GAMMA.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER(NPTW=3)
      PARAMETER(NPTS=100)
C     NOTE: these two parameter statements are rewritten
C     by extracthopf_prepare.script, which is a script
C     file created by extracthopf_prepare.f
      DIMENSION IARRAY(9),PARRAY(7)
      DIMENSION U(3*NPTW,NPTS),UDOT(3*NPTW,NPTS)
      DIMENSION Z(NPTS),PINNER(NPTS)
      DIMENSION VREAL(NPTW,NPTS),VIMAG(NPTW,NPTS)
      DIMENSION VAREAL(NPTW,NPTS),VAIMAG(NPTW,NPTS)
      DIMENSION DVREAL(NPTW,NPTS),DVIMAG(NPTW,NPTS)
      DIMENSION PARDOT(4),IPAR(4)
      CALL GINFO(INFO)
C     Read in the fort.8 file
      OPEN(12,FILE='fort.8'
     &,STATUS='OLD')
      REWIND(12)
      DO 505 I505=1,1000
         READ(12,*,END=400)(IARRAY(J),J=1,9)
         IF (IARRAY(3).EQ.9) THEN
            IF (IARRAY(7).NE.NPTS) THEN
               OPEN(66,FILE='../temp_files/message.txt'
     &              ,STATUS='NEW')
               WRITE(66,'(''ERROR: in extracthopf.f, the value'')')
               WRITE(66,'(''       of IARRAY(7)='',I8,'' differs''
     &              )')IARRAY(7)
               WRITE(66,'(''       from the expected value='',I8
     &              )')NPTS
               CLOSE(66)
               CALL IOUT(INFO,'error')
               CLOSE(12)
               CALL ISTOP(INFO)
            ENDIF
            DO 300 ILOOP3=1,IARRAY(7)
               READ(12,*,END=400)Z(ILOOP3),
     &              (U(I,ILOOP3),I=1,3*NPTW)
 300        CONTINUE
            READ(12,*)(IPAR(I),I=1,4)
            READ(12,*)(PARDOT(I),I=1,4)
            DO 506 ILOOP3=1,IARRAY(7)
               READ(12,*)(UDOT(I,ILOOP3),I=1,3*NPTW)
 506        CONTINUE
            READ(12,*)(PARRAY(I),I=1,7)
            CLOSE(12)
            GOTO 302
         ELSE
            DO 301 ILOOP3=1,IARRAY(9)
               READ(12,*,END=400)
 301        CONTINUE
         ENDIF
 505  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: loop 505 finished'',
     &     '' in extracthopf.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CALL ISTOP(INFO)
 302  CONTINUE
      GEND=PARRAY(4)
C     GEND is the value of gamma for this solution
      OPEN(19,FILE='../loci/data_files/hopf.gstart'
     &,STATUS='NEW')
      WRITE(19,'(F14.8)')GEND
      CLOSE(19)
C     Check whether the target value of gamma has been reached
      OPEN(16,FILE='../temp_files/spectrum.grangemax'
     &,STATUS='OLD')
      READ(16,*)GMIN,GMAX
      CLOSE(16)
      OPEN(23,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(23)
      DO 230 I230=1,13
         READ(23,*)
 230  CONTINUE
      READ(23,*)GATOL
      CLOSE(23)
      IF (GEND.GT.(GMAX-GATOL)) THEN
         IOCOME=0
      ELSE
         IOCOME=1
      ENDIF
C     IOCOME=0 MEANS THAT THE TARGET VALUE WAS REACHED.
C     NOTE THAT OVERSHOOT IS OK: THE POINT IS TO CHECK
C     WHETHER THE CONTINUATION HAS COVERED THE WHOLE
C     OF THE RANGE OF GAMMA CONTINUATION, UP TO 
C     <approx_gamma_at_fold>+0.5*grange. HERE 
C     <approx_gamma_at_fold> IS CALCULATED IN THE
C     SPECTRUM CONTINUATION, AND grange IS GIVEN
C     IN defaults.input.
C     IOCOME=1 MEANS THAT THE TARGET VALUE WAS NOT 
C     REACHED. IN THIS CASE THE CALLING SCRIPT 
C     sbdy.script WILL TERMINATE THE CURRENT ITERATION 
C     OF THE SOLUTION LOOP (THE iwhich LOOP) SO THE
C     REMAINDER OF THE PROGRAM IS NOT REALLY NEEDED,
C     BUT I LEAVE IT TO RUN ANYWAY IN CASE THE OUTPUT
C     FILES ARE HELPFUL IN SORTING OUT THE PROBLEM.
      OPEN(16,FILE='../temp_files/extracthopf.output'
     &,STATUS='NEW')
      WRITE(16,'(I2)')IOCOME
      CLOSE(16)
C     Now convert from the eigenfunction U 
C     to V=U*EXP(-I*GAMMA*Z)
      DO 330 ILOOP3=1,IARRAY(7)
         CGZ=COS(GEND*Z(ILOOP3))
         SGZ=SIN(GEND*Z(ILOOP3))
C     Note: Z varies between 0 and 1 across one period, 
C           as required
         DO 331 ILOOP4=1,NPTW
            UREAL=U(2*ILOOP4+NPTW-1,ILOOP3)
            UIMAG=U(2*ILOOP4+NPTW,ILOOP3)
            VREAL(ILOOP4,ILOOP3)=UREAL*CGZ+UIMAG*SGZ
            VIMAG(ILOOP4,ILOOP3)=UIMAG*CGZ-UREAL*SGZ
 331     CONTINUE
 330  CONTINUE
C     Now get an estimate of the derivative of the 
C     eigenfunction with respect to (i*gamma).
      DO 440 ILOOP3=1,IARRAY(7)
         CGZ=COS(GEND*Z(ILOOP3))
         SGZ=SIN(GEND*Z(ILOOP3))
C     Note: Z varies between 0 and 1 across one period, 
C           as required
         DO 441 ILOOP4=1,NPTW
            UAREAL=UDOT(2*ILOOP4+NPTW,ILOOP3)
     &           /PARDOT(1)
            UAIMAG=-UDOT(2*ILOOP4+NPTW-1,ILOOP3)
     &           /PARDOT(1)
            VAREAL(ILOOP4,ILOOP3)=UAREAL*CGZ+UAIMAG*SGZ
     &           -Z(ILOOP3)*VREAL(ILOOP4,ILOOP3)
            VAIMAG(ILOOP4,ILOOP3)=UAIMAG*CGZ-UAREAL*SGZ
     &           -Z(ILOOP3)*VIMAG(ILOOP4,ILOOP3)
C           UDOT contains the derivatives of the eigenfunction U
C           with respect to arc length. PARDOT(1) is the derivative
C           of the phase difference gamma with respect to arc length. 
C           I want dV/d(i*gamma) = d/d(i*gamma)(U*exp(-i*gamma*z)
C                                = (-i*dU/d(gamma))*exp(-i*gamma*z) - z*V
C                                = (UAREAL+i*UAIMAG)*exp(-i*gamma*z) - z*V
 441     CONTINUE
 440  CONTINUE
C     The complication now is that VAREAL and VAIMAG contain 
C     (in general) components of the eigenfunction, whereas the
C     integral condition I am imposing on the derivative of the
C     eigenfunction implies orthogonality. Therefore this component
C     must be subtracted. The situation is:
C         (VAREAL+I*VAIMAG) = (DVREAL+I*DVIMAG) + K*(VREAL+I*VIMAG)
C     where DVREAL and DVIMAG are the real and imaginary components
C     of the required derivatives. Taking the inner product of the
C     above equation with (VREAL+I*VIMAG) (i.e. multiplying by
C     (VREAL-I*VIMAG) and integrating across one period of the wave),
C     and using the orthogonality of (DVREAL+I*DVIMAG) and
C     (VREAL+I*VIMAG), and the fact that (VREAL+I*VIMAG) has norm=1,
C     implies that K is equal to the inner product of (VAREAL+I*VAIMAG)
C     and (VREAL+I*VIMAG). Now use this to calculate K and hence
C     (DVREAL+I*DVIMAG). Note that superficially the formula for K
C     appears to give a complex number, but the above "displayed" 
C     formula implies that the imaginary part must be zero (take
C     the inner product the other way around, showing that K is equal
C     to its complex conjugate). Therefore it is only necessary to 
C     calculate the real part of the inner product.
      DO 442 ILOOP3=1,IARRAY(7)
         PINNER(ILOOP3)=0.0D0
         DO 443 ILOOP4=1,NPTW
            PINNER(ILOOP3)=PINNER(ILOOP3)+
     &           VAREAL(ILOOP4,ILOOP3)*VREAL(ILOOP4,ILOOP3)+
     &           VAIMAG(ILOOP4,ILOOP3)*VIMAG(ILOOP4,ILOOP3)
 443     CONTINUE
 442  CONTINUE
      K=0.0D0
      DO 444 ILOOP3=2,IARRAY(7)
         K=K+0.5D0*(PINNER(ILOOP3-1)+PINNER(ILOOP3))
     &        *(Z(ILOOP3)-Z(ILOOP3-1))
 444  CONTINUE
      DO 445 ILOOP3=1,IARRAY(7)
         DO 446 ILOOP4=1,NPTW
            DVREAL(ILOOP4,ILOOP3)=VAREAL(ILOOP4,ILOOP3)
     &           -K*VREAL(ILOOP4,ILOOP3)
            DVIMAG(ILOOP4,ILOOP3)=VAIMAG(ILOOP4,ILOOP3)
     &           -K*VIMAG(ILOOP4,ILOOP3)
 446     CONTINUE
 445  CONTINUE
C     Now write the output file with the "initial guess" for
C     the solution
      OPEN(13,FILE='../loci/hopf.dat'
     &,STATUS='NEW')
      DO 447 ILOOP3=1,IARRAY(7)
         WRITE(13,9000)Z(ILOOP3),(U(I,ILOOP3),I=1,NPTW),
     &        (VREAL(I,ILOOP3),VIMAG(I,ILOOP3),I=1,NPTW),
     &        (DVREAL(I,ILOOP3),DVIMAG(I,ILOOP3),I=1,NPTW)
 447  CONTINUE
      CLOSE(13)
C     Now write the parameter file, with the real and
C     imaginary parts of the eigenvalue, and initial
C     guesses for the real and imaginary parts of the
C     first derivative of the eigenvalue with respect
C     to (i*gamma). This file is read in by the 
C     auto subroutine STPNT.
      OPEN(20,
     &     FILE='../temp_files/extracthopf.params'
     &     ,STATUS='NEW')
      WRITE(20,9002)PARRAY(5)
      WRITE(20,9002)PARRAY(6)
      WRITE(20,9002)PARDOT(3)/PARDOT(1)
      WRITE(20,9002)-PARDOT(2)/PARDOT(1)
      CLOSE(20)
C     Note that PARDOT contains derivatives with respect to arc
C     length. Hence it is necessary to divide by the derivative 
C     of gamma with respect to arc-length (which should never be 
C     zero) and also to swap real and imaginary parts and add the 
C     minus sign for the imaginary part (this is because I want 
C     derivatives with respect to i*gamma not gamma).
C     Note also that PARDOT(2) and PARDOT(3) refer to the
C     derivative with respect to arc length of IPAR(2) and
C     IPAR(3), which are parameters 5 and 6 respectively, i.e.
C     the real and imaginary parts of the eigenvalue.
      CALL ISTOP(INFO)
C========================================================
C     The next part of the program contains an estimation
C     of the entries in ../temp_files/extracthopf.params
C     using the fort.7 file. I wrote this when trying to
C     use zeros as initial guesses for the derivative of
C     the eigenfunction. I have decided to replace these
C     by estimates based on the fort.8 file, for
C     consistency, but I retain the code below 
C     (commented out) for possible future use.
C========================================================
CC     NOW WRITE THE DATA FILE THAT IS READ BY STPNT TO
CC     GET THE PARAMETER VALUES FOR THE FIRST AUTO RUN 
CC     OF hopf. THE FILE extracthopf.params HAS FOUR LINES,
CC     ONE NUMBER PER LINE, GIVING IN ORDER: 
CC     RE(LAMBDA), IM(LAMBDA), RE((d/d(I*GAMMA))(LAMBDA)), 
CC     IM((d/d(I*GAMMA))(LAMBDA)) (THE LAST TWO ARE RATHER
CC     CRUDE ESTIMATES).
CC     NOTE THAT d/d(I*GAMMA)(LAMBDA)=d/d(GAMMA)(IM(LAMBDA))
CC                                    -I*d/d(GAMMA)(RE(LAMBDA))
C      OPEN(11,FILE='fort.7'
C     &,STATUS='OLD')
C      REWIND(11)
C      DO 601 I=1,12
C         READ(11,*,END=610)IDUMMY
C 601  CONTINUE
C      DO 602 I=1,10000
C         IF (I.GT.1) THEN
C            EVALRP=EVALR
C            EVALIP=EVALI
C            GAMMAP=GAMMA
C         ENDIF
C         READ(11,*,END=610)IDUMMY,IPT,ITY,ILAB,GAMMA,
C     &        RNORM,UMAX1,UMAX2,EVALR,EVALI
C         IF (ILAB.EQ.IARRAY(4)) THEN
C            IF (I.GT.1) THEN
C               OPEN(20,
C     &          FILE='../temp_files/extracthopf.params'
C     &          ,STATUS='NEW')
C               WRITE(20,9002)EVALR
C               WRITE(20,9002)EVALI
C               WRITE(20,9002)(EVALI-EVALIP)/(GAMMA-GAMMAP)
C               WRITE(20,9002)(EVALRP-EVALR)/(GAMMA-GAMMAP)
C               CLOSE(20)
C               GOTO 620
C            ELSE
C               OPEN(66,FILE='../temp_files/message.txt'
C     &              ,STATUS='NEW')
C               WRITE(66,'(
C     &          ''ERROR: in extracthopf.f, the required'')')
C               WRITE(66,'(
C     &          ''       solution label is the first entry'')')
C               WRITE(66,'(
C     &          ''       in the file fort.7'')')
C               CLOSE(66)
C               CALL IOUT(INFO,'error')
C               CLOSE(11)
C               CALL ISTOP(INFO)
C            ENDIF
C         ENDIF
C 602  CONTINUE
C      OPEN(66,FILE='../temp_files/message.txt'
C     &,STATUS='NEW')
C      WRITE(66,'(''ERROR: loop 602 finished'',
C     &     '' in extracthopf.f'')')
C      CLOSE(66)
C      CALL IOUT(INFO,'error')
C      CLOSE(11)
C      CALL ISTOP(INFO)
C 610  OPEN(66,FILE='../temp_files/message.txt'
C     &,STATUS='NEW')
C      WRITE(66,'(''ERROR: in extracthopf.f, file fort.7'')')
C      WRITE(66,'(''       finished without finding the'')')
C      WRITE(66,'(''       required solution label ='',
C     &     I8)')IARRAY(4)
C      CLOSE(66)
C      CALL IOUT(INFO,'error')
C      CLOSE(11)
C      CALL ISTOP(INFO)
C 620  CLOSE(11)
C      CALL ISTOP(INFO)
C===========================================================
 400  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: premature end of file 12'',
     &     '' in extracthopf.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CALL ISTOP(INFO)
 9000 FORMAT(16E18.10E2)
 9002 FORMAT(E18.10E2)
C     NOTE: format statements 9000 is rewritten by
C     extracthopf_prepare.script, which is a script
C     file created by extracthopf_prepare.f
      END
