C+    spectrum_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR THE
C+    EIGENVALUE SPECTRUM CALCULATIONS. NOTE THAT r.spectrum.6
C+    IS ONLY USED FOR CALCULATING STABILITY BOUNDARIES OF HOPF
C+    TYPE, BUT IS ALWAYS CREATED TO AVOID WRITING A SEPARATE 
C+    PROGRAM. NOTE ALSO THAT r.spectrum.4 AND r.spectrum.6 ARE
C+    NEVER USED DIRECTLY; RATHER THEY ARE EITHER COPIED OR 
C+    REWRITTEN TO r.spectrum.5 BY check_direction.f OR
C+    check_direction_hopf.f RESPECTIVELY.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      PI=ACOS(-1.0D0)
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      READ(12,*)
      READ(12,*)
      READ(12,*)DS,DSMIN,DSMAX
      CLOSE(12)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)IDUMY1,IDUMY2,IDUMY3,NMX,IDUMY4,NMXDUM
      READ(11,*)A0,A1
      READ(11,*)
      READ(11,*)EPSL,EPSU,EPSS
      READ(11,*)
      READ(11,*)GEXTRA
      CLOSE(11)
      DS=ABS(DS)
      DSMIN=ABS(DSMIN)
      DSMAX=ABS(DSMAX)
C-----
      RLDUM=1.0D6
C     A big number to prevent this limit being reached
      RLSMLL=0.1D0
C-----
      NDIM=3*NPTW
      IPS=4
      ILP=0
      NICP=5
      ICPDUM=7
C     A dummy (i.e. unused) parameter, for first stage
      ICP1=4
      ICP2=5
      ICP3=6
      ICP4=2
      ICP5=1
C     Note that ICP5 is not an active continuation parameter
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=3*NPTW
      NINT=3
      MXBF=10
      IID=2
      ITMX=8
      ITNW=7
      NWTN=3
      JAC=0
      RL1=2*PI+GEXTRA+DSMAX*1.1D0
      RL0=-RL1
C     Note: rl0 and rl1 have abs values a little above 2*pi+gextra so 
C           that contination occurs, starting at one periodic (gamma=0) 
C           eigenvalue, to a little beyond the required end point. This 
C           is to facilitate the detection of folds, in case there 
C           is a fold at or very close to the end point.
C           Only values of gamma between 0 and 2*pi+gextra 
C           are used for plotting the spectrum (the program 
C           prepare_to_plot_spectrum.f excludes gamma values outside 
C           this range, prior to plotting).
      NPRDUM=1
      NPR=NMX
      IADS=1
      IRSDUM=1
      IRS1=NMXDUM+1
C     because nprdum=1
      IRS2=NMXDUM+2
C     because nprdum=1
      IRS3=NMXDUM+3
C     because nprdum=1
C-----
      OPEN(20,FILE='../spectrum/r.spectrum.1'
     &,STATUS='NEW')
      OPEN(21,FILE='../spectrum/r.spectrum.2'
     &,STATUS='NEW')
      OPEN(22,FILE='../spectrum/r.spectrum.3'
     &,STATUS='NEW')
      OPEN(23,FILE='../spectrum/r.spectrum.4'
     &,STATUS='NEW')
      OPEN(24,FILE='../spectrum/r.spectrum.6'
     &,STATUS='NEW')
      WRITE(20,'(I8,I2,I8,I2)')NDIM,IPS,IRSDUM,ILP
      WRITE(21,'(I8,I2,I8,I2)')NDIM,IPS,IRS1,ILP
      WRITE(22,'(I8,I2,I8,I2)')NDIM,IPS,IRS2,ILP
      WRITE(23,'(I8,I2,I8,I2)')NDIM,IPS,IRS3,ILP
      WRITE(24,'(I8,I2,I8,I2)')NDIM,IPS,IRS3,ILP
      WRITE(20,'(6I8)')NICP,ICPDUM,ICP2,ICP3,ICP4,ICP5
      WRITE(21,'(6I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5
      WRITE(22,'(6I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5
      WRITE(23,'(6I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5
      WRITE(24,'(6I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5
      WRITE(20,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(22,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(23,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(24,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(20,'(I8,2E11.2E2,2F8.2)')NMXDUM,-RLDUM,RLDUM,A0,A1
      WRITE(21,'(I8,2F20.8,2F8.2)')NMX,-RLSMLL,RLSMLL,A0,A1
      WRITE(22,'(I8,2F20.8,2F8.2)')NMX,RL0,RL1,A0,A1
      WRITE(23,'(I8,2F20.8,2F8.2)')NMX,RL0,RL1,A0,A1
      WRITE(24,'(I8,F20.8,'' RL1 '',2F8.2)')NMX,RL0,A0,A1
C     Note that the RL1 text string will be replaced
C       by a number in fullspectrum.script
      WRITE(20,'(I8,6I3)')NPRDUM,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(I8,6I3)')NPR,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(22,'(I8,6I3)')NPR,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(23,'(I8,6I3)')NPR,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(24,'(I8,6I3)')NPR,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(20,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(22,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(23,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(24,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(20,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(22,'(3E16.8E2,I3)')(-DS),DSMIN,DSMAX,IADS
      WRITE(23,'(3E16.8E2,I3)')DSMAX,DSMIN,DSMAX,IADS
      WRITE(24,'(3E16.8E2,I3)')DSMAX,DSMIN,DSMAX,IADS
C     Note: 2*pi and 2*pi+gextra are both specified as output points 
C           because typically they are close together, and are 
C           reached with the continuation step size being relatively
C           large. Therefore if only one is specified as an output point,
C           then the other will usually be jumped over.
C     Note also: the reason for excluding the output at 2*pi+gextra if
C                gextra is small relative to the minimum step size is that
C                otherwise, the continuation might treat the two output 
C                points as the same. It is important that the two outputs
C                can be numerically resolved during continuation.
      WRITE(20,'(''0'',/,''0'',/,''0'')')
      WRITE(21,'(''0'',/,''0'',/,''0'')')
      WRITE(22,'(''0'',/,''0'',/,''1'',/,''-4 0.000000000'')')
      IF (GEXTRA.LT.(10.0D0*DSMIN)) THEN
         WRITE(23,9000)2*PI
      ELSE
         WRITE(23,9001)2*PI,2*PI+GEXTRA
      ENDIF
      WRITE(24,'(''0'',/,''0'',/,''0'')')
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
      CLOSE(24)
C-----
      STOP
 9000 FORMAT('0',/,'0',/,'1',/,'4',F14.9)
 9001 FORMAT('0',/,'0',/,'2',/,'4',F14.9,/,'4',F14.9)
      END
